package net.sf.jcc.model.parser.uml2;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.StartElement;

import net.sf.jcc.model.parser.ElementHandler;
import net.sf.jcc.model.parser.ElementHandlerException;
import net.sf.jcc.model.parser.InternalStore;
import net.sf.jcc.model.parser.ParseContext;
import net.sf.jcc.model.parser.UnexpectedException;
import net.sf.jcc.model.parser.XMLParsedElement;

import org.apache.commons.lang.ArrayUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;

public class TypeHandler implements ElementHandler
{
	@Override
	public String getName() 
	{
		return getClass().getSimpleName();
	}
	
	@Override
	public void handleElement(ParseContext parseContext)
			throws ElementHandlerException 
	{
		XMLParsedElement pElement = (XMLParsedElement)parseContext.getParsedElement();
		
		StartElement element = pElement.getElement();
		
		Attribute attr = element.getAttributeByName(new QName("http://schema.omg.org/spec/XMI/2.1", "idref"));
		String ref = attr.getValue();
		
		ParseContext parentContext = parseContext.getParent();
		if (parentContext == null)
		{
			return;
		}
		ModelElement parent = (ModelElement) parentContext.getVariable(PackagedElementHandler.PARENT);
		
		if (parent == null)
		{
			return;
		}
	
		parent.addReference(element.getName(), ref);
	}

}
